#include <mega8.h>   //
#include <stdio.h>   //            
#include <delay.h>   //                  
#include <16_2lcd.h>//


// 
static float Fx;
unsigned long int N, N0, M, M0;
unsigned int Perepol_Timer0=0, Perepol_Timer1=0, count_T1, count_T0;

//   Timer/Counter 0
interrupt [TIM0_OVF] void timer0_ovf_isr(void){
Perepol_Timer0++;//   1
}

//   Timer/Counter 1
interrupt [TIM1_OVF] void timer1_ovf_isr(void){
Perepol_Timer1++;//   1
}

//   Timer/Counter 1
interrupt [TIM1_CAPT] void timer1_capt_isr(void){
count_T0=TCNT0;//  TCNT0   
count_T1=ICR1;//  ICR1   
TIMSK&=0xDF;//   
} 


//  
void main(void){

unsigned char lcd_buffer[16];//   

PORTC=0x00;
DDRC=0x00;

PORTB=0x00;
DDRB=0b00001000;

PORTD=0x00;
DDRD=0b01101111;


// Timer/Counter 0
TCCR0=0x07;
TCNT0=0x00;

// Timer/Counter 1
TCCR1A=0x00;
TCCR1B=0x41;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: 1000,000 kHz
// Mode: Phase correct PWM top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x19;
TCNT2=0x00;
OCR2=3;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x05;

lcd_init();// LCD HD44780


while (1){// 
#asm("cli")
Perepol_Timer1=0;// 
Perepol_Timer0=0;// 
#asm("sei")// 
TIMSK|=0x20;// 
while ((TIMSK&0x20)==0x20){}//   
N0=(((unsigned long int)(Perepol_Timer1))<<16)+count_T1; //     
M0=(((unsigned long int)(Perepol_Timer0))<<8)+count_T0;//     
delay_ms(1000);//  1 
TIMSK|=0x20;// 
while ((TIMSK&0x20)==0x20){}//   
N=(((unsigned long int)(Perepol_Timer1))<<16)+count_T1; //     
M=(((unsigned long int)(Perepol_Timer0))<<8)+count_T0;//     
N=N-N0;//       
M=M-M0;//       
Fx=8000000.0*(float)M/(float)N;//   
sprintf(lcd_buffer, "F=%0.1fHz", Fx);
lcd_clear();
lcd_puts(lcd_buffer);
} }